#!/usr/bin/env python

import ConfigParser, os, sys, argparse, socket, errno,re
import numpy as np

ToolDir       = os.path.dirname(__file__)
ToolIncludeDir = os.path.join(ToolDir,'include')
sys.path.append(ToolIncludeDir)



from  Node         import *
from  Element      import *
from  MeshUtils    import *
from  NodeSet      import *

from  genMesh      import *

from  genT         import *
from  genWing      import *

from convertmesh   import *

from mergeFiles    import *


import os.path







#---------------- main --------------

def main():
  parser = argparse.ArgumentParser('GMSH', add_help=False )

  parser.add_argument('-msh2inp',   action='store_true',  dest='msh2inp'  )
  parser.add_argument('-msh2merge',   action='store_true',  dest='msh2merge'  )
  parser.add_argument('-generate',  action='store_true',  dest='generate' )
  parser.add_argument('-case' ,     nargs='?'          ,  dest='casename' )  
  parser.add_argument('-list' ,     nargs='+'          ,  dest='listFiles' )


  args=parser.parse_args()

  casename='default'

  if not args.casename == None :
      casename=args.casename

  if args.msh2inp:
    outFile=casename+'.inp'
    inputFile=casename+'.msh'
    if os.path.isfile( inputFile ) :
        convertMesh(inputFile,outFile)
        
        
    else:
        print 'msh not found: ' +  inputFile
        
  if args.msh2merge :
    if args.listFiles==None:
        print 'Nothing to merge '
        exit(0)
        
    if len(args.listFiles)==0:
        print 'No files given'
        exit(0)
        
    if len(args.listFiles) == 1:
        print 'only one file ?  use -msh2inp'
        exit(0)
     
    mergeFiles(args.listFiles)
          
        

  if args.generate:
    
    genGeoT(casename)
    genE2(casename)
    genE3(casename)
    
    
    
    
    

## call main #

if __name__ == "__main__":
    main()
