# -*- coding: iso-8859-1 -*-


import numpy as np

eps=2e-12
epsx2=2*eps
epsx3=3*eps
epsx4=4*eps

from  Node         import *

def tofloat(text):
    try:
        val=float(text)
        return val
    except:
        print 'cannot convert to float ' + text
        exit(1)



def toint(text):
    try:
        val=int(text)
        return val
    except:
        print 'cannot convert to int ' + text
        exit(1)


def crossProduct2Nodes(node1, node2):

    try:
         if node1.isInitialized() and node2.isInitialized():
             a=np.array([node1.x, node1.y, node1.z])
             b=np.array([node2.x, node2.y, node2.z])
             return np.cross(a,b)
         else :
            print  'Error: node1/2 were not initialized'
            exit(1)
    except:
         print 'Error you a passing a non Node '
         exit(1)


def distance2Nodes(node1, node2):

    try:
         if node1.isInitialized() and node2.isInitialized():
             x=node1.x-node2.x; y=node1.y-node2.y; z= node1.z-node2.z;
             d=np.sqrt(x*x + y*y +z*z)
             return d
         else :
            print  'Error: node1/2 were not initialized'
            exit(1)
    except:
         print 'Error you a passing a non Node '
         exit(1)




def planeEquation(n1, n2, n3):

    try:
         if n1.isInitialized() and n2.isInitialized() and \
            n3.isInitialized() :
            n3_2=n3-n2;   n1_2=n1-n2
            cp=crossProduct2Nodes(n3_2,n1_2)
            #ax+by+cz+d=0 , a b c  is found by cross product, d evaluanting
            d= -(cp[0]*n1.x + cp[1]*n1.y + cp[2]*n1.z)
            return np.array([ cp[0], cp[1], cp[2], d])

         else :
            print  'Error: in sameSemiPlane node(s) not initialized'
            exit(1)
    except:
         print 'Error: in sameSemiPlane. Passing a non Node '
         exit(1)


def isInPlane( eqcff , node ):

    try:
         if node.isInitialized() :
          
           val=float(eqcff[0]*node.x  + eqcff[1]*node.y + eqcff[2]*node.z + eqcff[3])
           val=abs(val)
     
           if abs(val)< 2*(eps):
              return True
           else:
              return False
         else :
            print  'Error: in isInPlane, node not initialized, coeff not array'
            exit(1)
    except:
         print 'Error: in isInPlanee. Passing a non Node or np.array '
         exit(1)




def sameSemiPlane(p1, p2 , a, b ):

    try:
       if p1.isInitialized() and p2.isInitialized() and \
          a.isInitialized() and  b.isInitialized():
          b_a=b-a   ;  p1_a= p1-a ; p2_a= p2-a
          #b_a.Print()
          #p1_a.Print()
          cp1=crossProduct2Nodes(b_a, p1_a)
          cp2=crossProduct2Nodes(b_a, p2_a)

          #print 'cp1: ' + str(cp1)
          #print 'dot:: ' + str(np.dot(cp1,cp2))
          if np.dot(cp1,cp2) >= 0 :
              return True
          else  :
              return False

       else :
            print  'Error: in sameSemiPlane node(s) not initialized'
            exit(1)
    except:
         print 'Error: in sameSemiPlane. Passing a non Node '
         exit(1)




# Subs
POINT3D='     Point({id_}) = {{ {x_},{y_},{z_} }};\n'

POINT3D_4='    Point ({id_}) = {{ {x_},{y_},{z_},{gs_} }};\n'

TRNSLINE= '     Transfinite Line {{ {lineList_} }}= {args_}; \n '
PROGRESSION='     Using Progression '

LINE =  '     Line ({id_}) = {{ {p1_},{p2_} }};\n'
LLOOP = '     Line Loop ({id_}) = {{ {list_} }};\n'
PSURF = '     Plane Surface({id_}) = {{ {list_} }};\n'


#element Types
C3D4='4'
C3D10='11'
S6='9'
