# -*- coding: iso-8859-1 -*-


from  Node       import *
from  Element    import *
from  MeshUtils  import *



# Simple class  to  accumulate set
class  NodeSet:
      name='UNDEFINED'
      nodeList=list()



#  Search class to find nodes given point
#  can  search point on a line
class NodeSetPartial:
    point1=Node()
    point2=Node()
    point3=Node()
    point4=Node()
    name='undef'
    nodeList=list()
    tolerance=0.0


    def setPoint1(self, pointDef,nodes):
        pointDef=pointDef.upper()
        self.point1=Node()
        if 'COORDINATES' in pointDef:
           pointDef=pointDef.replace('COORDINATES','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           pointDef=pointDef.split()

           if len(pointDef)!=3:
              print 'Error: point 1 does not have 3 coordinates'
              exit(1)

           self.point1.x = tofloat(pointDef[0])
           self.point1.y = tofloat(pointDef[1])
           self.point1.z = tofloat(pointDef[2])

        elif 'ID'  in pointDef:
           pointDef=pointDef.replace('ID','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           testId= -1
           id_= toint(pointDef)
           for node in nodes:
               if id_==node.id:
                  testId=id_
                  self.point1.id= testId
                  self.point1.x = node.x
                  self.point1.y = node.y
                  self.point1.z = node.z
                  break
           if testId == -1:
              print 'Error: point1 was not found in nodes, id: ' + str(id_)
              exit(1)
        else :
            print 'Error: point1 has to be ''coordinates'' or ''id'' '
            exit(1)


    def setPoint2(self, pointDef,nodes):
        pointDef=pointDef.upper()
        self.point2=Node()
        if 'COORDINATES' in pointDef:
           pointDef=pointDef.replace('COORDINATES','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           pointDef=pointDef.split()
           if len(pointDef)!=3:
              print 'Error: point 1 does not have 3 coordinates'
              exit(1)

           self.point2.x = tofloat(pointDef[0])
           self.point2.y = tofloat(pointDef[1])
           self.point2.z = tofloat(pointDef[2])

        elif 'ID'  in pointDef:
           pointDef=pointDef.replace('ID','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           testId= -1
           id_= toint(pointDef)
           for node in nodes:
               if id_==node.id:
                  testId=id_
                  self.point2.id= testId
                  self.point2.x = node.x
                  self.point2.y = node.y
                  self.point2.z = node.z
                  break
           if testId == -1:
              print 'Error: point2 was not found in nodes, id: ' + str(id_)
              exit(1)

        else :
            print 'Error: point2 has to be ''coordinates'' or ''id'' '
            exit(1)

    def setPoint3(self, pointDef,nodes):
        pointDef=pointDef.upper()
        self.point3=Node()
        if 'COORDINATES' in pointDef:
           pointDef=pointDef.replace('COORDINATES','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           pointDef=pointDef.split()
           if len(pointDef)!=3:
              print 'Error: point 1 does not have 3 coordinates'
              exit(1)

           self.point3.x = tofloat(pointDef[0])
           self.point3.y = tofloat(pointDef[1])
           self.point3.z = tofloat(pointDef[2])

        elif 'ID'  in pointDef:
           pointDef=pointDef.replace('ID','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           testId= -1
           id_= toint(pointDef)
           for node in nodes:
               if id_==node.id:
                  testId=id_
                  self.point3.id= testId
                  self.point3.x = node.x
                  self.point3.y = node.y
                  self.point3.z = node.z
                  break
           if testId == -1:
              print 'Error: point3 was not found in nodes, id: ' + str(id_)
              exit(1)

        else :
            print 'Error: point3 has to be ''coordinates'' or ''id'' '
            exit(1)


    def setPoint4(self, pointDef,nodes):
        pointDef=pointDef.upper()
        self.point4=Node()
        if 'COORDINATES' in pointDef:
           pointDef=pointDef.replace('COORDINATES','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           pointDef=pointDef.split()
           if len(pointDef)!=3:
              print 'Error: point 1 does not have 3 coordinates'
              exit(1)

           self.point4.x = tofloat(pointDef[0])
           self.point4.y = tofloat(pointDef[1])
           self.point4.z = tofloat(pointDef[2])

        elif 'ID'  in pointDef:
           pointDef=pointDef.replace('ID','')
           pointDef=pointDef.replace('(','')
           pointDef=pointDef.replace(')','')
           testId= -1
           id_= toint(pointDef)
           for node in nodes:
               if id_==node.id:
                  testId=id_
                  self.point4.id= testId
                  self.point4.x = node.x
                  self.point4.y = node.y
                  self.point4.z = node.z
                  break
           if testId == -1:
              print 'Error: point4 was not found in nodes, id: ' + str(id_)
              exit(1)

        else :
            print 'Error: point4 has to be ''coordinates'' or ''id'' '
            exit(1)




    def getNodeSet(self):
        return nodeList

    def getNodeList(self):
        return nodeList



    def calculateNodeSet(self, nodes):
    # routes to calculate line (2point ), surface triangle(3 points) and
    # surface 4 points (2 triangles)
        if   not self.point1.isInitialized() :
             print 'Error: point1 was not initialized'
             exit(1)

        elif self.point1.isInitialized() and \
             not self.point2.isInitialized() and \
             not self.point3.isInitialized() and \
             not self.point4.isInitialized() :
             print 'Info: adding one point to set'

        elif  self.point1.isInitialized() and \
              self.point2.isInitialized() and \
              not self.point3.isInitialized() and \
              not self.point4.isInitialized() :
              self.calculateNodeLineSet(nodes)

        elif self.point1.isInitialized() and \
             self.point2.isInitialized() and \
             self.point3.isInitialized() and \
             not self.point4.isInitialized() :
             self.calculateNodeTriangleLineSet(nodes)

        elif self.point1.isInitialized() and \
             self.point2.isInitialized() and \
             self.point3.isInitialized() and \
             self.point4.isInitialized() :
             self.calculateNodeSquareLineSet(nodes)



    def calculateNodeTriangleLineSet(self,nodes):
         d12=distance2Nodes(self.point1, self.point2)
         d13=distance2Nodes(self.point1, self.point3)
         d23=distance2Nodes(self.point2, self.point3)
         
         if d12<eps or  d13<eps or d23<eps:
            print 'Error: in calculateNodeTriangleLineSet. 2(3) match(es) eachother '
            exit(1)
         if abs((d13+d23)-d12)<eps  or \
            abs((d12+d23)-d13)<eps  or \
            abs((d12+d13)-d23)<eps :
            print 'Error: in calculateNodeTriangleLineSet. 2(3) are colinear. use 2 points instead'
            exit(1)

         #plane equation def by 3p
         eqcoff=planeEquation(self.point1,  self.point2, self.point3)
         
         self.nodeList=list()
         nodeSet=set()
         #baricenter coordinates and is in plane
         for node_ in nodes:
            if sameSemiPlane(node_,self.point1,self.point2,self.point3) and \
               sameSemiPlane(node_,self.point2,self.point1,self.point3) and \
               sameSemiPlane(node_,self.point3,self.point1,self.point2) and \
               isInPlane(eqcoff, node_):
               nodeSet.add(node_.id)
               
         for node in nodeSet:
             self.nodeList.append(node)

         print 'NodeSetPartial (3):' + self.name + '  has found '+ str( len( self.nodeList)) +' nodes'


    def calculateNodeSquareLineSet(self,nodes):
        #split in 2 triangles   p1 p2 p3  , p1 p3 p4 both clockwise
        eqcoff=planeEquation(self.point1,  self.point2, self.point3)
        if not  isInPlane(eqcoff,self.point4):
           print 'Error: in calculateNodeSquareLineSet. n4 is not coplanar'
           exit(1)
         #t1
        d12=distance2Nodes(self.point1, self.point2)
        d13=distance2Nodes(self.point1, self.point3)
        d23=distance2Nodes(self.point2, self.point3)
        if d12<eps or  d13<eps or d23<eps:
            print 'Error: in calculateNodeSquareLineSet 1t. 2(3) match(es) eachother '
            exit(1)
        if abs((d13+d23)-d12)<eps  or \
           abs((d12+d23)-d13)<eps  or \
           abs((d12+d13)-d23)<eps :
           print 'Error: in calculateNodeSquareLineSet 1t. 2(3) are colinear. use 2 points instead'
           exit(1)
        #t2
        d13=distance2Nodes(self.point1, self.point3)
        d34=distance2Nodes(self.point3, self.point4)
        d14=distance2Nodes(self.point1, self.point4)
        if d13<eps or d34<eps or d14<eps:
           print 'Error: in calculateNodeSquareLineSet 2t. 2(3) match(es) eachother '
           exit(1)
        if abs((d13+d34)-d14)<eps  or \
           abs((d34+d14)-d13)<eps  or \
           abs((d13+d14)-d34)<eps :
           print 'Error: in calculateNodeSquareLineSet 2t. 2(3) are colinear. use 2 points instead'
           exit(1)
        
        self.nodeList=list()
        nodeSet=set()
        
        #T1
        for node_ in nodes:
            if sameSemiPlane(node_,self.point1,self.point2,self.point3) and \
               sameSemiPlane(node_,self.point2,self.point1,self.point3) and \
               sameSemiPlane(node_,self.point3,self.point1,self.point2) and \
               isInPlane(eqcoff, node_):
               nodeSet.add(node_.id)     
               
               
           
        #T2
        eqcoff=planeEquation(self.point1,  self.point3, self.point4)
        for node_ in  nodes:
            if sameSemiPlane(node_,self.point1,self.point3,self.point4) and \
               sameSemiPlane(node_,self.point3,self.point1,self.point4) and \
               sameSemiPlane(node_,self.point4,self.point1,self.point3) and \
               isInPlane(eqcoff, node_):
               nodeSet.add(node_.id) 
               
        for node in nodeSet:       
            self.nodeList.append(node)

        print 'NodeSetPartial (4):' + self.name + '  has found '+ str( len( self.nodeList)) +' nodes'


    def  calculateNodeLineSet(self,nodes):

        p1 = self.point1.getCoordinates()
        p2 = self.point2.getCoordinates()
        xd = p2 - p1

        self.nodeList=list()
        nodeSet=set()
        
        if abs(xd[0])< eps  and abs(xd[1])< eps:
           print 'NodeSetPartial: ' +self.name+' lies on parallel axis (Z-Z)'
           if p1[2]>p2[2]:
             minVal=p2[2]
             maxVal=p1[2]
           else:
             minVal=p1[2]
             maxVal=p2[2]

           minVal=minVal-self.tolerance
           maxVal=maxVal+self.tolerance

           for node_ in nodes:
                x=node_.x
                y=node_.y
                z=node_.z
                if (z>minVal and z<maxVal) and \
                    abs(x-p1[0]) < self.tolerance and \
                    abs(y-p1[1]) < self.tolerance :
                    nodeSet.add(node_.id)

        elif abs(xd[1])< eps  and abs(xd[2])< eps:
           print 'NodeSetPartial: ' +self.name+' lies on parallel axis(X-X)'
           if p1[0]>p2[0]:
             minVal=p2[0]
             maxVal=p1[0]
           else:
             minVal=p1[0]
             maxVal=p2[0]

           minVal=minVal-self.tolerance
           maxVal=maxVal+self.tolerance

           for node_ in nodes:
                x=node_.x
                y=node_.y
                z=node_.z
                if (x>minVal and x<maxVal) and \
                   abs(y-p1[1]) < self.tolerance and \
                   abs(z-p1[2]) < self.tolerance:
                   nodeSet.add(node_.id)
                   

        elif abs(xd[0])< eps  and abs(xd[2])<eps:
           print 'NodeSetPartial: ' +self.name+' lies on parallel axis (Y-Y)'
           if p1[1]>p2[1]:
             minVal=p2[1]
             maxVal=p1[1]
           else:
             minVal=p1[1]
             maxVal=p2[1]

           minVal=minVal-self.tolerance
           maxVal=maxVal+self.tolerance

           for node_ in nodes:
                x=node_.x
                y=node_.y
                z=node_.z
                if (y>minVal and y<maxVal) and \
                   abs(x-p1[0]) < self.tolerance and \
                   abs(z-p1[2]) < self.tolerance:
                   nodeSet.add(node_.id)
           

        else :
            minVal=0-self.tolerance
            maxVal=1+self.tolerance

            if abs(xd[0]) < eps :
               print 'Line on constant X'
               for node_ in nodes:
                   ty=0 ; tz=0 ;

                   #Y parametric
                   y=node_.y
                   ty=(y-p1[1])/(xd[1])
                   #Z parametric
                   z=node_.z
                   tz=(z-p1[2])/(xd[2])

                   x=node_.x

                   if abs(ty-tz)< self.tolerance and \
                      ty>minVal  and ty<maxVal  and\
                      abs(x-p1[0])<self.tolerance:
                      nodeSet.add(node_.id)
  

            elif abs(xd[1]) < eps:
               print  'Line on constant Y'
               for node_ in nodes:
                   tx=0 ; tz=0 ;

                   #X parametric
                   x=node_.x
                   tx=(x-p1[0])/(xd[0])
                   #Z parametric
                   z=node_.z
                   tz=(z-p1[2])/(xd[2])

                   y=node_.y

                   if abs(tx-tz)< self.tolerance and \
                      tx>minVal  and tx<maxVal  and\
                      abs(y-p1[1])<self.tolerance:
                      nodeSet.add(node_.id)

            elif abs(xd[2]) < eps:
               print  'Line on constant Z'
               for node_ in nodes:
                   tx=0 ; ty=0 ;

                   #X parametric
                   x=node_.x
                   tx=(x-p1[0])/(xd[0])
                   #Y parametric
                   y=node_.y
                   ty=(y-p1[1])/(xd[1])

                   z=node_.z

                   if abs(tx-ty)< self.tolerance and \
                      tx>minVal  and tx<maxVal  and\
                      abs(z-p1[2])<self.tolerance:
                      nodeSet.add(node_.id)

            else:

               for node_ in nodes:
                 tx=0 ; ty=0 ; tz=0

                 #X parametric
                 x=node_.x
                 tx=(x-p1[0])/(xd[0])

                 #Y parametric
                 y=node_.y
                 ty=(y-p1[1])/(xd[1])

                 #z parametric
                 z=node_.z
                 tz=(z-p1[2])/(xd[2])

                 if abs(tx-ty)< self.tolerance and \
                    abs(ty-tz)< self.tolerance and \
                    abs(tx-tz)< self.tolerance and \
                    tz>minVal  and tz<maxVal :
                    nodeSet.add(node_.id)  


        for node in nodeSet:
            self.nodeList.append(node)
            
        print 'NodeSetPartial(2):' + self.name + '  has found '+ str( len( self.nodeList)) +' nodes'
