import ConfigParser, os, sys, argparse, socket, errno,re
import numpy as np


from  Node         import *
from  Element      import *
from  MeshUtils    import *
from  NodeSet      import *

from  genMesh      import *

from  genT         import *
from  genWing        import *


import os.path




def convertMesh(inputFile, outFile):
  import numpy as np


  fileReader = open(inputFile,'r+')


  nodeFlag=0
  nodecnt=0
  nnodes=0
  eleFlag=0
  elecnt=0

  NodeSetDict=list()
  NodeSetDictFlag=False

  nodes=list()
  elements=list()
  elements_c3d4=list()
  elements_c3d10=list()
  elements_s6=list()


  for line in fileReader.readlines():
      line=line.strip()

      if len(line)== 0 :
        continue

      line=line+'\n'
      list_param=line.split(',')

      keyword=list_param[0].upper().strip()

      if keyword =='$NODES':
         nodeFlag=1
         continue

      if keyword=='$ENDNODES':
         nodeFlag=0
         continue

      if nodeFlag == 1 :
         nodeFlag=2
         continue

      if nodeFlag == 2:
         nLine=line.split()
         node_=Node()
         node_.id=int(nLine[0])

         node_.setX( tofloat(nLine[1])  )
         node_.setY( tofloat(nLine[2]) )
         node_.setZ( tofloat(nLine[3]) )
         nodes.append(node_)
         nodecnt=nodecnt+1
         continue

      if keyword == '$ELEMENTS':
         eleFlag=1
         continue

      if keyword=='$ENDELEMENTS':
         eleFlag=0
         continue

      if eleFlag == 1 :
         eleFlag=2
         continue

      if eleFlag == 2:
         eLine=line.split()
         if eLine[1] == '2':
            element_=Element()
            element_.id=toint(eLine[0])
            nodes_=list()
            nodes_.append(toint(eLine[5]))
            nodes_.append(toint(eLine[6]))
            nodes_.append(toint(eLine[7]))
            element_.nodes=nodes_
            elements.append(element_)
            elecnt=elecnt+1

         elif eLine[1] == C3D4:
            element_=Element()
            element_.id=toint(eLine[0])
            nodes_=list()
            nodes_.append(toint(eLine[5]))
            nodes_.append(toint(eLine[6]))
            nodes_.append(toint(eLine[7]))
            nodes_.append(toint(eLine[8]))
            element_.nodes=nodes_
            element_.type='C3D4'
            elements_c3d4.append(element_)

         elif eLine[1] == S6:
            element_=Element()
            element_.id=toint(eLine[0])
            nodes_=list()
            nodes_.append(toint(eLine[5]))
            nodes_.append(toint(eLine[6]))
            nodes_.append(toint(eLine[7]))
            nodes_.append(toint(eLine[8]))
            nodes_.append(toint(eLine[9]))
            nodes_.append(toint(eLine[10]))
            element_.nodes=nodes_
            elements_s6.append(element_)

         elif eLine[1] == C3D10:
            element_=Element()
            element_.id=toint(eLine[0])
            nodes_=list()
            nodes_.append(toint(eLine[5]))
            nodes_.append(toint(eLine[6]))
            nodes_.append(toint(eLine[7]))
            nodes_.append(toint(eLine[8]))
            nodes_.append(toint(eLine[9]))
            nodes_.append(toint(eLine[10]))
            nodes_.append(toint(eLine[11]))
            nodes_.append(toint(eLine[12]))
            nodes_.append(toint(eLine[14]))
            nodes_.append(toint(eLine[13]))
            element_.nodes=nodes_
            element_.type='C3D10'
            elements_c3d10.append(element_)

         continue


      if keyword == '$NODESET':
         NodeSetDictFlag=True
         nodeSet=NodeSetPartial()
         continue

      if keyword == '$ENDNODESET' :
         NodeSetDictFlag=False
         NodeSetDictPartial.append(nodeSet)
         continue

      if NodeSetDictFlag:
         lineParams=re.split(',',line)
         for params in lineParams:     # line with 1 or more parameters
             params=params.strip()
             tuple=re.split('=',params)
             if len(tuple)!=2:
                print 'Warning parameter without value! ignoring' + str(tuple)
                continue
             if tuple[0].upper()=='TOLERANCE':
                nodeSet.tolerance=float(tuple[1].strip())
             if tuple[0].upper()=='NAME':
                nodeSet.name=tuple[1].strip()
             if tuple[0].upper()=='POINT1':
                nodeSet.setPoint1(tuple[1].strip(), nodes)
             if tuple[0].upper()=='POINT2':
                nodeSet.setPoint2(tuple[1].strip(), nodes)
             if tuple[0].upper()=='POINT3':
                nodeSet.setPoint3(tuple[1].strip(), nodes)
             if tuple[0].upper()=='POINT4':
                nodeSet.setPoint4(tuple[1].strip(), nodes)


#  dump
  fileWriter = open(outFile,'w+')
  cnt=0
  fileWriter.write('*NODE, NSET=nodes\n')
  for node in nodes:
      fileWriter.write(str(node.id)+', '+str(node.x)+', '+str(node.y)+ ', '+str(node.z)+'\n')
      cnt=cnt+1

  cnt=1
  '''
  if len(elements_s6)>0:
     fileWriter.write('*ELEMENT,TYPE=S6\n')
     for element in elements_s6:
         fileWriter.write(str(cnt)+',')
         cnt=cnt+1
         for node in  element.nodes:
            fileWriter.write(str(node)+',')
         fileWriter.write('\n')
  '''

  if len(elements_c3d10)>0:
     fileWriter.write('*ELEMENT,TYPE=C3D10\n')
     for element in elements_c3d10:
         fileWriter.write(str(cnt)+',')
         cnt=cnt+1
         for node in  element.nodes:
            fileWriter.write(str(node)+',')
         fileWriter.write('\n')

  if len(elements_c3d4)>0:
     fileWriter.write('*ELEMENT,TYPE=C3D4\n')
     for element in elements_c3d4:
         fileWriter.write(str(cnt)+',')
         cnt=cnt+1
         for node in element.nodes:
            fileWriter.write(str(node)+',')
         fileWriter.write('\n')



  for nodeSet in  NodeSetDict:
    print
    print  'NodeSet:' +nodeSet.name
    print  'P1 ('+str(nodeSet.point1.id)+'):' +str(nodeSet.point1.getCoordinates())
    print  'P2 ('+str(nodeSet.point2.id)+'):' +str(nodeSet.point2.getCoordinates())
    print  'P3 ('+str(nodeSet.point3.id)+'):' +str(nodeSet.point3.getCoordinates())
    print  'P4 ('+str(nodeSet.point4.id)+'):' +str(nodeSet.point4.getCoordinates())

    nodeSet.calculateNodeSet(nodes)

    fileWriter.write('*NSET,NSET='+ nodeSet.name+'\n')
    for node_ in nodeSet.nodeList:
        fileWriter.write(str(node_)+',\n')


  fileWriter.close()


  meshInfo=dict()
  meshInfo['nodes:']=nodes
  meshInfo['elements:']=elements
  meshInfo['ele_c3d4:']=elements_c3d4
  meshInfo['ele_c3d10:']=elements_c3d10
  meshInfo['ele_s6:']=elements_s6
  meshInfo['nodeSets:']=NodeSetDict
  
  return meshInfo