# -*- coding: iso-8859-1 -*-
import numpy as np

from  MeshUtils  import *
from  T_dimensions import *


def genE2(casename) :
 
   outFile=casename+'_ele2.geo'  

   fileWriter=open(outFile,'w+')

   fileWriter.write('// ELE 2 **** \n')

   fileWriter.write('//ELE 2 : Points \n')

   fileWriter.write('// Points at V1 Ievel\n')

   id=15   
   x=-(H4+H5+gapx); y=V1+gapy; z=Z     
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   id=16
   x=-(H4+gapx); y=V1+gapy; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   fileWriter.write('// Points at V2 level\n')
      
   id=17      
   x=-(H4+H5+gapx); y=V2+gapy; z=Z      
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   id =18
   x=-(H3+gapx); y=V2+gapy; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   fileWriter.write('// ELE 2 : Lines \n')
      
   id=20
   p1=15;p2=16      
   fileWriter.write(LINE.format( id_=id , p1_=str(p1),p2_=str(p2) ))
      
   id=21
   p1=15;p2=17
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
     
   id=22
   p1=16;p2=18
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=23
   p1=17;p2=18
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
   
   fileWriter.write('// ELE 2 : Lines Loop/Surfaces \n')
   id=7
   list='20,22,-23,-21'   
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='7'   
   fileWriter.write(PSURF.format( id_=id,list_=list ))
   
   fileWriter.write('// Spacing L20\n')
   LineList='20'   
   args=str(nL20)   
   fileWriter.write(TRNSLINE.format( lineList_=LineList,args_=args ))
   
   fileWriter.write('// Spacing L21\n')
   
   LineList='21'   
   args=str(nL21)   
   fileWriter.write(TRNSLINE.format( lineList_=LineList,args_=args ))   
   
   
   fileWriter.write('//Spacing L23\n')
   LineList='23'
   args=str(nL23)
   fileWriter.write(TRNSLINE.format( lineList_=LineList,args_=args ))
   
   fileWriter.write('// Spacing L22 contact\n')
   LineList='22'   
   args=str(nL22)   
   fileWriter.write(TRNSLINE.format( lineList_=LineList,args_=args ))
   
   
   fileWriter.write('\n\n// Extrude \n')
   surflist='{7}'
   fileWriter.write('Extrude{-8,0,0} { \n')
   fileWriter.write(' Surface'+surflist+';\n')
   fileWriter.write(' Layers{1};\n')
   fileWriter.write('}')
   
   fileWriter.close()
   
   
   
def genE3(casename):
   
   outFile=casename+'_ele3.geo'  

   fileWriter=open(outFile,'w+')
   fileWriter.write('// ELE 3 **** \n')      
   fileWriter.write('// ELE 3 : Points \n')
      
   fileWriter.write('// Points at V1 leve|\n')
      
   id=19      
   x=H3+gapx; y=V1+gapy; z=Z      
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   id=20
   x=H4+H6+gapx; y=V1+gapy; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   fileWriter.write('// Points at V2 leve|\n')
     
   id=21      
   x= H4+gapx; y=V2+gapy; z=Z     
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   id=22
   x=H4+H6+gapx; y=V2+gapy; z=Z 
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)))
      
   fileWriter.write('// ELE 3 : Lines \n')
      
   id=24   
   p1=19;p2=20      
   fileWriter.write(LINE.format( id_=id , p1_=str(p1), p2_=str(p2) ))
      
   id=26
   p1=20;p2=22
   fileWriter.write(LINE.format( id_=id , p1_=str(p1), p2_=str(p2) ))

   id=27
   p1=21;p2=22
   fileWriter.write(LINE.format( id_=id , p1_=str(p1), p2_=str(p2) ))
      
   id=25
   p1=19;p2=21
   fileWriter.write(LINE.format( id_=id , p1_=str(p1), p2_=str(p2) ))
      
   fileWriter.write('// ELE 3 : Lines Loop/Surfaces \n')
   id=8
   list='24,26,-27,-25'      
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='8'
   fileWriter.write(PSURF.format( id_=id,list_=list ))
     
   fileWriter.write('// Spacing L24\n')
      
   lineList='24'      
   args=str(nL24)      
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
      
   fileWriter.write('// Spacing L26\n')
   lineList='26'
   args=str(nL26)
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
      
      
   fileWriter.write('// Spacing L27\n')
   lineList='27'
   args=str(nL27)
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
      
   fileWriter.write('// Spacing L25 contact \n')
      
   lineList='25'      
   args=str(nL25)   
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
      
   fileWriter.write('\n\n// Extrude \n')
   surflist='{8}'
   fileWriter.write('Extrude{-8,0,0} { \n')
   fileWriter.write(' Surface'+surflist+';\n')
   fileWriter.write(' Layers{1};\n')
   fileWriter.write('}')
   
   fileWriter.close()
   