import ConfigParser, os, sys, argparse, socket, errno,re
import numpy as np


from  Node         import *
from  Element      import *
from  MeshUtils    import *
from  NodeSet      import *

from  genMesh      import *

from  genT         import *
from  genWing      import *
from  eleFile      import *


import os.path






def mergeFiles( listFiles ):
    
    
    
    for iFile in listFiles: 
       if not os.path.isfile(iFile) :
          print 'file not found '  + str(iFile)
          exit(1)
           
           
    objFiles=dict()
     
     
    
    #for each file  init 
    for iFile in listFiles:
        eleIFile=eleFile(iFile)
        objFiles[iFile]=eleIFile
        

    #for each eleFile  convert from read msh files, 
    for iFile in listFiles:
        print objFiles[iFile].fileName
        objFiles[iFile].convertMesh()
    
    
        
    nodesTotal=list()   
    nodeSetTotalDict=dict()
    nodeCnt=0
    
    
    elements_c3d10Total=list()
    elements_c3d10TotalDict=dict()
    ele_c3d10Cnt=0
    
    for iFile in listFiles:
                
        nodesPartial=objFiles[iFile].nodes
        nodeSetPartial=list()
    
        
        for node in nodesPartial:
            node_=Node()            
            node_.id=node.id + nodeCnt
            nodeSetPartial.append( node_.id )
            node_.setX( node.getX() )
            node_.setY( node.getY() )
            node_.setZ( node.getZ() )
            nodesTotal.append(node_)
       
        nodeSetName_=objFiles[iFile].nodeSetName
        nodeSetTotalDict[nodeSetName_]=nodeSetPartial
        
        element_c3d10Partial=objFiles[iFile].elements_c3d10
        elementSet_c3d10Partial=list()
        
        for iEle in element_c3d10Partial:
            ele_=Element()
            nodes_=list()
            for node in iEle.nodes :
               node_.append(  node.id + nodeCnt)
            ele_.nodes=nodes
            
        nodeCnt=nodeCnt+len(nodesPartial)
        
    fileWriter=open('total.inp','w+')
    fileWriter.write('*NODE, NSET=Nall\n')
    for node in nodesTotal:
      fileWriter.write(str(node.id)+', '+str(node.x)+', '+str(node.y)+ ', '+str(node.z)+'\n')
    
    for iNodeSetKey, nodeSetList in nodeSetTotalDict.iteritems() :
        fileWriter.write('*NSET,NSET='+ str(iNodeSetKey) +'\n')
        for node_ in nodeSetList:
            fileWriter.write(str(node_)+',\n')
        
    fileWriter.close()
  
        
           
           
    